Bullet Collision Detection & Physics Library: btConcaveShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Attributes | List of all members
btConcaveShape Class Referenceabstract

The btConcaveShape class provides an interface for non-moving (static) concave shapes. More...

`#include <btConcaveShape.h>`

Inheritance diagram for btConcaveShape:
[legend]
Collaboration diagram for btConcaveShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConcaveShape ()
virtual | ~btConcaveShape ()
virtual void | processAllTriangles (btTriangleCallback *callback, const btVector3 &aabbMin, const btVector3 &aabbMax) const =0
virtual btScalar | getMargin () const
virtual void | setMargin (btScalar collisionMargin)
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const =0
| getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t.
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
virtual void | setLocalScaling (const btVector3 &scaling)=0
virtual const btVector3 & | getLocalScaling () const =0
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const =0
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
virtual void | serializeSingleShape (btSerializer *serializer) const

## Protected Attributes
btScalar | m_collisionMargin
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btConcaveShape class provides an interface for non-moving (static) concave shapes.

It has been implemented by the btStaticPlaneShape, btBvhTriangleMeshShape and btHeightfieldTerrainShape.

Definition at line 37 of file btConcaveShape.h.

## Constructor & Destructor Documentation

## ◆ btConcaveShape()

btConcaveShape::btConcaveShape | ( |  | ) |

Definition at line 18 of file btConcaveShape.cpp.

## ◆ ~btConcaveShape()

btConcaveShape::~btConcaveShape | ( |  | ) |
| virtual

Definition at line 22 of file btConcaveShape.cpp.

## Member Function Documentation

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btConcaveShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ getMargin()

virtual btScalar btConcaveShape::getMargin | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Reimplemented in btGImpactMeshShapePart, and btSdfCollisionShape.

Definition at line 52 of file btConcaveShape.h.

## ◆ processAllTriangles()

virtual void btConcaveShape::processAllTriangles | ( | btTriangleCallback * | callback,
|  | const btVector3 & | aabbMin,
|  | const btVector3 & | aabbMax ) const
| pure virtual

Implemented in btBvhTriangleMeshShape, btEmptyShape, btGImpactMeshShape, btGImpactMeshShapePart, btGImpactShapeInterface, btHeightfieldTerrainShape, btScaledBvhTriangleMeshShape, btSdfCollisionShape, btSoftBodyCollisionShape, btStaticPlaneShape, and btTriangleMeshShape.

## ◆ setMargin()

virtual void btConcaveShape::setMargin | ( | btScalar | collisionMargin | ) |
| inlinevirtual

Implements btCollisionShape.

Reimplemented in btGImpactMeshShape, btGImpactMeshShapePart, btGImpactShapeInterface, and btSdfCollisionShape.

Definition at line 56 of file btConcaveShape.h.

## Member Data Documentation

## ◆ m_collisionMargin

btScalar btConcaveShape::m_collisionMargin
| protected

Definition at line 41 of file btConcaveShape.h.

The documentation for this class was generated from the following files:

- btConcaveShape.h
- btConcaveShape.cpp